/*
 * RCS info: $Source: $
 *           $Revision: $
 *           $Date: $
 *           $Author: $
 *
 * Copyright (c) 2012 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 쐬F
 * 쐬ҁF
 * t@CFdsp_arith.h
 * Tv  FŒ菬_w\֐
 *==========================================================================*/

#ifndef _FPF_ARITH
#define __FPF_ARITH


#ifdef __FPF_MAX_16BIT

#define _FPF_SFT_LOWORD 8       // 16 / 2
#define _FPF_SFT_WORD   16
#define _FPF_WORD_HIBIT  (0x8000U)

//16rbg
typedef unsigned int _FPF_WORD;

//8rbg
typedef unsigned char _FPF_SWORD;

//Lp}N
#define _FPF_LOWORD(dw) (0xFFU & dw)
#define _FPF_HIWORD(dw) (0xFFU & (dw >> _FPF_SFT_LOWORD))

#else

#define _FPF_SFT_LOWORD 16  // 32/2
#define _FPF_SFT_WORD   32

//32rbg
typedef unsigned int _FPF_WORD;

//16rbg
typedef unsigned short _FPF_SWORD;

//Lp}N
#define _FPF_LOWORD(dw) (0xFFFFU & dw)
#define _FPF_HIWORD(dw) (0xFFFFU & (dw >> _FPF_SFT_LOWORD))

#endif

//64rbg
typedef struct {
    _FPF_WORD dwHigh; //32rbg
    _FPF_WORD dwLow;  //32rbg
    short isneg;    /**< sign-bit -- T if number is negative */
    short isbig;    /**< sizeflag -- T if number won't fit in signed 64-bit */
} _FPF_DWORD;


#ifndef __FPF_MAX_16BIT

//64rbg
typedef unsigned long long int _FPF_LWORD;
typedef long long _FPF_LWORDInt;

#define _FPF_LWORD_LO(dw) (0xFFFFFFFFU & dw)
#define _FPF_LWORD_HI(dw) (0xFFFFFFFFU & (dw >> 32))

#define _FPF_WORD_HIBIT  (0x80000000U)
#define _FPF_LWORD_HIBIT (0x8000000000000000ULL)

//128rbg
typedef struct {
    _FPF_LWORD dwHigh; //64rbg
    _FPF_LWORD dwLow;  //64rbg
    short isneg;    /**< sign-bit -- T if number is negative */
    short isbig;    /**< sizeflag -- T if number won't fit in signed 64-bit */
} _FPF_QWORD;
#endif


//
// 32rbg̉Z
//
static _FPF_WORD _fpf_Add32(
            _FPF_WORD dw1, _FPF_WORD dw2, _FPF_WORD *lpdwCarry)
{
    _FPF_WORD dwTmp1;
    _FPF_WORD dwTmp2;
    _FPF_WORD dwSum;
    _FPF_WORD dwCarry;

    dwTmp1 = _FPF_LOWORD(dw1) + _FPF_LOWORD(dw2);
    dwTmp2 = _FPF_HIWORD(dw1) + _FPF_HIWORD(dw2) + _FPF_HIWORD(dwTmp1);
    dwSum = _FPF_LOWORD(dwTmp1) | (dwTmp2 << _FPF_SFT_LOWORD);
    dwCarry = _FPF_HIWORD(dwTmp2);

    //Jオ̊i[
    if (lpdwCarry) *lpdwCarry =dwCarry;
    return dwSum;
}

//
// 64rbg̉Z
//
static _FPF_DWORD _fpf_Add64(_FPF_DWORD qw1, _FPF_DWORD qw2)
{
    _FPF_WORD dwCarry, tmp;
    _FPF_DWORD qwSum;

    qwSum.dwLow  =_fpf_Add32(qw1.dwLow, qw2.dwLow, &dwCarry);
    qwSum.dwHigh =_fpf_Add32(
                _fpf_Add32(qw1.dwHigh, qw2.dwHigh, &tmp), dwCarry, &tmp);
    return qwSum;
}

#ifndef __FPF_MAX_16BIT

//
// 128rbg̉Z
//
static _FPF_QWORD _fpf_Add128(_FPF_QWORD a, _FPF_QWORD b)
{
    _FPF_QWORD sum;
    a.isneg = !(_FPF_LWORD_HIBIT & a.dwHigh);
    b.isneg = !(_FPF_LWORD_HIBIT & b.dwHigh);

    if (a.isneg == b.isneg){
        sum.isneg = a.isneg;
        sum.dwHigh = a.dwHigh + b.dwHigh;
        sum.dwLow = a.dwLow + b.dwLow;
        if ((sum.dwLow < a.dwLow) || (sum.dwLow < b.dwLow)){
            sum.dwHigh ++;
        }
        sum.isbig = sum.dwHigh || (sum.dwLow >> 63);
        return sum;
    }
    if ((b.dwHigh > a.dwHigh) ||
            ((b.dwHigh == a.dwHigh) && (b.dwLow > a.dwLow))) {
        _FPF_QWORD tmp = a;
        a = b;
        b = tmp;
    }

    sum.isneg = a.isneg;
    sum.dwHigh = a.dwHigh - b.dwHigh;
    sum.dwLow = a.dwLow - b.dwLow;

    if (sum.dwLow > a.dwLow){
        sum.dwHigh--;
    }

    sum.isbig = sum.dwHigh || (sum.dwLow >> 63);
    return sum;
}

static _FPF_QWORD _fpf_Add128U(_FPF_QWORD a, _FPF_QWORD b)
{
    _FPF_QWORD sum;

    if (a.isneg == b.isneg){
        sum.isneg = a.isneg;
        sum.dwHigh = a.dwHigh + b.dwHigh;
        sum.dwLow = a.dwLow + b.dwLow;
        if ((sum.dwLow < a.dwLow) || (sum.dwLow < b.dwLow)){
            sum.dwHigh ++;
        }
        sum.isbig = sum.dwHigh || (sum.dwLow >> 63);
        return sum;
    }
    if ((b.dwHigh > a.dwHigh) ||
            ((b.dwHigh == a.dwHigh) && (b.dwLow > a.dwLow))) {
        _FPF_QWORD tmp = a;
        a = b;
        b = tmp;
    }

    sum.isneg = a.isneg;
    sum.dwHigh = a.dwHigh - b.dwHigh;
    sum.dwLow = a.dwLow - b.dwLow;

    if (sum.dwLow > a.dwLow){
        sum.dwHigh--;
    }

    sum.isbig = sum.dwHigh || (sum.dwLow >> 63);
    return sum;
}
#endif


//
//Q̕␔
//
static _FPF_DWORD _fpf_NComp64(_FPF_DWORD dw)
{
    _FPF_DWORD dw2 = { 0, 1 };

    dw.dwHigh = ~dw.dwHigh;
    dw.dwLow =  ~dw.dwLow;
    dw = _fpf_Add64( dw, dw2 );
    return dw;
}

#ifndef __FPF_MAX_16BIT
//
// Q̕␔
//
static _FPF_QWORD _fpf_NComp128( _FPF_QWORD dw )
{
    _FPF_QWORD dw2 = { 0, 1, 0, 0};

    dw.isneg = 0;
    dw.dwHigh = ~dw.dwHigh;
    dw.dwLow =  ~dw.dwLow;
    dw = _fpf_Add128U( dw, dw2 );
    return dw;
}
#endif

//64rbǧZ
static _FPF_DWORD _fpf_Sub64(_FPF_DWORD qw1, _FPF_DWORD qw2)
{
    return _fpf_Add64(qw1, _fpf_NComp64(qw2));
}

//
//Z (32rbg)
//

static _FPF_WORD _fpf_Mul32(
                _FPF_WORD dw1, _FPF_WORD dw2, _FPF_WORD* lpdwCarry)
{
    //Iyhꂼ, 16rbgɕ
    _FPF_SWORD wLow1  =_FPF_LOWORD(dw1);
    _FPF_SWORD wLow2  =_FPF_LOWORD(dw2);
    _FPF_SWORD wHigh1 =_FPF_HIWORD(dw1);
    _FPF_SWORD wHigh2 =_FPF_HIWORD(dw2);

    //16rbgZ
    _FPF_WORD dwTmp1 =wLow1*wLow2;
    _FPF_WORD dwTmp2 =wLow1*wHigh2;
    _FPF_WORD dwTmp3 =wHigh1*wLow2;
    _FPF_WORD dwTmp4 =wHigh1*wHigh2;

    //߂l (ς̉32rbg) vZ
    _FPF_WORD dwRes, dwCarry1, dwCarry2;
    dwRes = _fpf_Add32(dwTmp1,
                _FPF_LOWORD(dwTmp2) << _FPF_SFT_LOWORD, &dwCarry1);
    dwRes = _fpf_Add32(dwRes,
                _FPF_LOWORD(dwTmp3) << _FPF_SFT_LOWORD, &dwCarry2);

    //Jオ (ς̏32rbg) vZEi[
    if (lpdwCarry){
        _FPF_WORD dwCarry, tmp;
        dwCarry =_fpf_Add32(dwTmp4,  _FPF_HIWORD(dwTmp2), &tmp);
        dwCarry =_fpf_Add32(dwCarry, _FPF_HIWORD(dwTmp3), &tmp);
        dwCarry =_fpf_Add32(dwCarry, dwCarry1, &tmp);
        dwCarry =_fpf_Add32(dwCarry, dwCarry2, &tmp);

        *lpdwCarry =dwCarry;
    }
    return dwRes;
}

//
// Zi64rbgj
//
static _FPF_DWORD _fpf_Mul64(_FPF_DWORD dw1, _FPF_DWORD dw2)
{
    _FPF_WORD dwCarry, tmp;
    _FPF_DWORD qw;

    qw.dwLow  =_fpf_Mul32(dw1.dwLow, dw2.dwLow, &dwCarry);
    qw.dwHigh =_fpf_Mul32(dw1.dwLow, dw2.dwHigh, &tmp)
                + _fpf_Mul32(dw1.dwHigh, dw2.dwLow, &tmp) + dwCarry;
    return qw;
}

#ifndef __FPF_MAX_16BIT
//
// 128rbgZ
//
static _FPF_QWORD _fpf_Mul128(_FPF_DWORD dw1, _FPF_DWORD dw2)
{
    _FPF_LWORDInt a;
    _FPF_LWORDInt b;
    _FPF_QWORD prod;
    _FPF_LWORD a0, a1;
    _FPF_LWORD b0, b1;
    _FPF_LWORD d, d0, d1;
    _FPF_LWORD e, e0, e1;
    _FPF_LWORD f, f0, f1;
    _FPF_LWORD g, g0, g1;
    _FPF_LWORD sum, carry, roll, pmax;

    a = ((_FPF_LWORD)dw1.dwHigh << 32) | dw1.dwLow;
    b = ((_FPF_LWORD)dw2.dwHigh << 32) | dw2.dwLow;

    prod.isneg = 0;
    if (0 > a){
        prod.isneg = !prod.isneg;
        a = -a;
    }

    if (0 > b){
        prod.isneg = !prod.isneg;
        b = -b;
    }

    a1 = a >> 32;
    a0 = a - (a1 << 32);

    b1 = b >> 32;
    b0 = b - (b1 << 32);

    d = a0 * b0;
    d1 = d >> 32;
    d0 = d - (d1 << 32);

    e = a0 * b1;
    e1 = e >> 32;
    e0 = e - (e1 << 32);

    f = a1 * b0;
    f1 = f >> 32;
    f0 = f - (f1 << 32);

    g = a1 * b1;
    g1 = g >> 32;
    g0 = g - (g1 << 32);

    sum = d1 + e0 + f0;
    carry = 0;
    /* Can't say 1<<32 cause cpp will goof it up; 1ULL<<32 might work */
    roll = 1 << 30;
    roll <<= 2;

    pmax = roll - 1;
    while (pmax < sum){
        sum -= roll;
        carry ++;
    }

    prod.dwLow = d0 + (sum << 32);
    prod.dwHigh = carry + e1 + f1 + g0 + (g1 << 32);
    // prod.isbig = (prod.hi || (sum >> 31));
    prod.isbig = prod.dwHigh || (prod.dwLow >> 63);

    if( prod.isneg ){
        prod.dwHigh = ~prod.dwHigh;
        prod.dwLow =  ~prod.dwLow;
    }

    return prod;
}
#endif

//
// 64rbgZ
//

#if(0) // dbg
static int _fpf_bitcount64(_FPF_LWORD n)
{
  return (int)log2(n)+1;
}


static _FPF_LWORD _fpf_Div64(_FPF_LWORD x, _FPF_LWORD y)
{
    unsigned short xb = _fpf_bitcount64(x);    // 폜̃rbg
    unsigned short yb = _fpf_bitcount64(y);    // ̃rbg
    unsigned short n = xb - yb + 1;    // [v(rbg+1)

    _FPF_LWORD a=0;
    _FPF_LWORD m=1;

//  printf("div64  : %lld %lld  \n", x, y);

    m <<= yb-1;
    while (n--){
        a <<= 1;
        if (m >= y){
            m -= y;
            a |= 1;
        }
        m <<= 1;
    }
    a *= x;
    a >>= (xb - 1);

  // 덷C(ła,1邢́A2ꍇ)
    m = y * a;
    while(x > m){
        m += y;
        if (x > m)
        a += 1;
    }
    return a;
}
#endif

//
// 64rbgVtg
//
static _FPF_DWORD _fpf_lshift64(_FPF_DWORD dw, int s)
{
    _FPF_WORD tmp;

    if( s > _FPF_SFT_WORD) {
        tmp = dw.dwLow << (s-_FPF_SFT_WORD);
        dw.dwLow  = 0;
        dw.dwHigh = tmp;
    } else {
        tmp = dw.dwLow >> (_FPF_SFT_WORD-s);
        if( s == _FPF_SFT_WORD ){
            dw.dwLow = 0;
        } else {
            dw.dwLow  = dw.dwLow << s;
        }
        dw.dwHigh = dw.dwHigh << s;
        dw.dwHigh   = dw.dwHigh | tmp;
    }
    return dw;
}

// 64rbgEVtg
//
static _FPF_DWORD _fpf_rshift64(_FPF_DWORD dw, int s)
{
    _FPF_WORD tmp;

    if( s > _FPF_SFT_WORD) {
        int tmp;
        tmp = ((int)dw.dwHigh) >> (s-_FPF_SFT_WORD);
        if( (int)dw.dwHigh < 0 ){
            dw.dwHigh = -1;
        } else {
            dw.dwHigh  = 0;
        }
        dw.dwLow = tmp;
    } else {
        tmp = dw.dwHigh << (_FPF_SFT_WORD-s);
        dw.dwLow  = dw.dwLow>>s;
        dw.dwHigh = (int)dw.dwHigh>>s;
        dw.dwLow   = dw.dwLow|tmp;
    }
    return dw;
}


#ifndef __FPF_MAX_16BIT
//
// 128rbgVtg
//
static _FPF_QWORD _fpf_lshift128(_FPF_QWORD dw, int s)
{
    _FPF_LWORD tmp;

    if( s > 64) {
        tmp = dw.dwLow << (s-64);
        dw.dwLow  = 0;
        dw.dwHigh = tmp;
    } else {
        tmp = dw.dwLow >> (64-s);
        if( s == 64 ){
            dw.dwLow  = 0;
        } else {
            dw.dwLow  = dw.dwLow << s;
        }
        dw.dwHigh = dw.dwHigh << s;
        dw.dwHigh   = dw.dwHigh | tmp;
    }
    return dw;
}

//
// 128rbgEVtg(long long)
//
static _FPF_QWORD _fpf_rshift128(_FPF_QWORD dw, int s)
{
    _FPF_LWORD tmp;

    if( s > 64) {
        tmp = ((long long)dw.dwHigh) >> (s-64);
        dw.dwHigh  = 0;
        dw.dwLow = tmp;
    } else {
        tmp = dw.dwHigh << (64-s);
        dw.dwLow  = dw.dwLow>>s;
        dw.dwHigh = (int)dw.dwHigh>>s;
        dw.dwLow   = dw.dwLow|tmp;
    }
    return dw;
}
#endif

//
// 64rbgr >=
//  A == B -> 0,   A < B -> 1, A > B -> -1 

static int _fpf_cmp64 ( _FPF_DWORD a, _FPF_DWORD b)
{
    a.isneg = !(_FPF_WORD_HIBIT & a.dwHigh);    // 1:+ 0:-
    b.isneg = !(_FPF_WORD_HIBIT & b.dwHigh);

    if ((0 == a.isneg) && b.isneg) return 1;    // A < B
    if (a.isneg && (0 == b.isneg)) return -1;   // A > B
    if (0 == a.isneg){
        if (a.dwHigh > b.dwHigh) return 1;      //
        if (a.dwHigh < b.dwHigh) return -1;     //
        if (a.dwLow > b.dwLow) return 1;
        if (a.dwLow < b.dwLow) return -1;
        return 0;
    }

    if (a.dwHigh > b.dwHigh) return -1;
    if (a.dwHigh < b.dwHigh) return 1;
    if (a.dwLow > b.dwLow) return -1;
    if (a.dwLow < b.dwLow) return 1;
    return 0;
}

static int _fpf_ge64( _FPF_DWORD dw1, _FPF_DWORD dw2)
{
    int r;

    r = _fpf_cmp64( dw1, dw2 );
    if( r <= 0 ){
        return 1;
    }
    return 0;
}

#ifndef __FPF_MAX_16BIT
//
// 128rbgr >=
//  A == B -> 0,   A < B -> 1, A > B -> -1 

static int _fpf_cmp128 ( _FPF_QWORD a, _FPF_QWORD b)
{
    a.isneg = !(_FPF_LWORD_HIBIT & a.dwHigh);    // 1:+ 0:-
    b.isneg = !(_FPF_LWORD_HIBIT & b.dwHigh);

    if ((0 == a.isneg) && b.isneg) return 1;    // A < B
    if (a.isneg && (0 == b.isneg)) return -1;   // A > B
    if (0 == a.isneg){
        if (a.dwHigh > b.dwHigh) return 1;      //
        if (a.dwHigh < b.dwHigh) return -1;     //
        if (a.dwLow > b.dwLow) return 1;
        if (a.dwLow < b.dwLow) return -1;
        return 0;
    }

    if (a.dwHigh > b.dwHigh) return -1;
    if (a.dwHigh < b.dwHigh) return 1;
    if (a.dwLow > b.dwLow) return -1;
    if (a.dwLow < b.dwLow) return 1;
    return 0;
}


static int _fpf_ge128( _FPF_QWORD dw1, _FPF_QWORD dw2)
{
    int r;

    r = _fpf_cmp128( dw1, dw2 );
    if( r <= 0 ){
        return 1;
    }
    return 0;
}
#endif


#endif

